/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { Base, runOn, markType, INotifyPropertyChanged_$type, PropertyChangedEventArgs } from "igniteui-react-core";
import { ElevationHelper } from "igniteui-react-core";
import { NativeUI } from "igniteui-react-core";
import { AnimationKeyFrameEffect } from "igniteui-react-core";
import { AnimationKeyFrameEffectTiming } from "igniteui-react-core";
import { KeyFrameAnimationFactory } from "igniteui-react-core";
import { BaseDOMEventProxy } from "igniteui-react-core";
import { ExpansionPanelUtilities } from "./ExpansionPanelUtilities";
import { BrushUtil } from "igniteui-react-core";
import { OnCollapsedEventArgs } from "./OnCollapsedEventArgs";
import { OnExpandedEventArgs } from "./OnExpandedEventArgs";
import { AnimationKeyFrameProperty } from "igniteui-react-core";
import { TranslateTransform } from "igniteui-react-core";
import { stringEmpty } from "igniteui-react-core";
/**
 * @hidden
 */
var ExpansionPanelView = /** @class */ /*@__PURE__*/ (function (_super) {
    tslib_1.__extends(ExpansionPanelView, _super);
    function ExpansionPanelView() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.i = null;
        _this.p = null;
        _this.g = null;
        _this.f = null;
        _this.o = null;
        _this.k = null;
        _this.n = null;
        _this.m = null;
        _this.l = null;
        return _this;
    }
    Object.defineProperty(ExpansionPanelView.prototype, "q", {
        get: function () {
            return this.p;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ExpansionPanelView.prototype, "h", {
        get: function () {
            return this.g;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ExpansionPanelView.prototype, "j", {
        get: function () {
            return this.i;
        },
        enumerable: true,
        configurable: true
    });
    ExpansionPanelView.prototype.ab = function () {
        this.q.setStyleProperty("display", "flex");
        this.q.setStyleProperty("flexDirection", "column");
        this.q.setStyleProperty("flexWrap", "no-wrap");
        this.q.setStyleProperty("alignItems", "left");
    };
    ExpansionPanelView.prototype.aj = function () {
        var a = this.h;
        var b = ElevationHelper.e(a.q, a.bn, a.bm, a.bi);
        this.q.setStyleProperty("box-shadow", b);
    };
    ExpansionPanelView.prototype.ak = function () {
        if (null == this.q) {
            return;
        }
        this.aj();
        this.ah();
        this.ai();
        this.ag();
        if (null != this.o) {
            NativeUI.j(this.o, this.h.bl);
        }
        if (null != this.k) {
            NativeUI.n(this.k, this.h.bj);
        }
        if (null != this.n) {
            NativeUI.n(this.n, this.h.bk);
        }
    };
    ExpansionPanelView.prototype.a = function (a) {
        return new AnimationKeyFrameEffect(0, this.k, 0, null, a);
    };
    ExpansionPanelView.prototype.b = function (a) {
        return new AnimationKeyFrameEffect(0, this.n, 0, null, a);
    };
    ExpansionPanelView.prototype.c = function (a) {
        return new AnimationKeyFrameEffect(0, this.o, 0, null, a);
    };
    ExpansionPanelView.prototype.d = function (a) {
        return new AnimationKeyFrameEffect(0, this.l, 0, null, a);
    };
    ExpansionPanelView.prototype.e = function (a) {
        return new AnimationKeyFrameEffect(0, this.m, 0, null, a);
    };
    ExpansionPanelView.prototype.u = function () {
        if (KeyFrameAnimationFactory.h == null) {
            KeyFrameAnimationFactory.h = this.j;
        }
    };
    ExpansionPanelView.prototype.r = function () {
        return this.l.outerHeight();
    };
    ExpansionPanelView.prototype.ac = function (a) {
        if (a == null) {
            this.i = null;
            return;
        }
        this.i = a;
        var b = a.rootWrapper;
        this.y(b);
    };
    ExpansionPanelView.prototype.ag = function () {
        if (null == this.f) {
            return;
        }
        var a = this.h.n;
        if (a) {
            this.f.svgPath = ExpansionPanelView.s;
        }
        else {
            this.f.svgPath = ExpansionPanelView.t;
        }
    };
    ExpansionPanelView.prototype.ah = function () {
        if (null != this.k) {
            var a = this.h.ab;
            this.k.setRawText(a);
        }
    };
    ExpansionPanelView.prototype.ai = function () {
        if (null != this.n) {
            var a = this.h.ah;
            this.n.setRawText(a);
        }
    };
    ExpansionPanelView.prototype.y = function (a) {
        this.p = a;
        this.ab();
    };
    ExpansionPanelView.prototype.z = function (a) {
        this.g = a;
    };
    ExpansionPanelView.prototype.aa = function () {
    };
    ExpansionPanelView.prototype.af = function (a) {
        var b = this.j;
        this.o = a;
        var c = b.createElement("div");
        this.o.append(c);
        this.v(c);
        var d = b.createElement("div");
        d.setStyleProperty("display", "flex");
        d.setStyleProperty("flex-direction", "column");
        d.setStyleProperty("justify-content", "space-evenly");
        d.setStyleProperty("align-items", "flex-start");
        this.o.append(d);
        var e = b.createElement("div");
        d.append(e);
        this.k = b.createElement("label");
        e.append(this.k);
        var f = b.createElement("div");
        d.append(f);
        this.n = b.createElement("label");
        f.append(this.n);
        this.o.setAttribute("tabindex", "0");
        this.o.setStyleProperty("display", "flex");
        this.o.setStyleProperty("flex-direction", "row");
        c.setStyleProperty("display", "flex");
        c.setStyleProperty("justify-content", "center");
        c.setStyleProperty("flex-direction", "column");
        c.setStyleProperty("margin", "0px 10px 0px 10px");
        c.setStyleProperty("flex", "none | 0 | content");
        this.ak();
        this.o.listen("click", runOn(this, this.w));
        this.o.listen("keydown", runOn(this, this.x));
    };
    ExpansionPanelView.prototype.v = function (a) {
        var _this = this;
        if (this.f != null) {
            return;
        }
        this.i.getPortal(a, "Icon", function (b) {
            var c = b.componentRef;
            _this.f = (c.i);
            _this.f.fill = ExpansionPanelView.al;
            _this.ag();
        }, false);
    };
    ExpansionPanelView.prototype.ae = function (a) {
        var b = this.j;
        this.m = a;
        this.m.setAttribute("tabindex", "1");
        this.m.setStyleProperty("overflow", "hidden");
    };
    ExpansionPanelView.prototype.ad = function (a) {
        var b = this.j;
        this.l = a;
    };
    ExpansionPanelView.prototype.w = function (a) {
        var b = a.originalEvent;
        var c = b.target;
        this.h.a2();
    };
    ExpansionPanelView.prototype.x = function (a) {
        var b = BaseDOMEventProxy.cu(a);
        var c = ExpansionPanelUtilities.c(a);
        switch (b) {
            case 9:
            case 3:
                this.h.a2();
                a.preventDefault();
                break;
            case 17:
                if (c == 1) {
                    this.h.au();
                    a.preventDefault();
                }
                break;
            case 15:
                if (c == 1) {
                    this.h.ar();
                    a.preventDefault();
                }
                break;
        }
    };
    ExpansionPanelView.$t = markType(ExpansionPanelView, 'ExpansionPanelView');
    ExpansionPanelView.al = BrushUtil.g(255, 33, 150, 243);
    ExpansionPanelView.t = "M16.59 8.59L12 13.17 7.41 8.59 6 10l6 6 6-6z";
    ExpansionPanelView.s = "M12 8l-6 6 1.41 1.41L12 10.83l4.59 4.58L18 14z";
    return ExpansionPanelView;
}(Base));
export { ExpansionPanelView };
/**
 * @hidden
 */
var ExpansionPanel = /** @class */ /*@__PURE__*/ (function (_super) {
    tslib_1.__extends(ExpansionPanel, _super);
    function ExpansionPanel() {
        var _this = _super.call(this) || this;
        _this.c = null;
        _this.onCollapsed = null;
        _this.onExpanded = null;
        _this.propertyChanged = null;
        _this.g = null;
        _this.aa = "Caption";
        _this.bb = null;
        _this.a4 = ExpansionPanel.bs;
        _this.a9 = null;
        _this.ba = null;
        _this.ag = stringEmpty();
        _this.be = null;
        _this.a5 = ExpansionPanel.bt;
        _this.bc = null;
        _this.bd = null;
        _this.p = -1;
        _this.o = ExpansionPanel.r;
        _this.m = true;
        _this.bf = null;
        _this.a6 = ExpansionPanel.bu;
        _this.bg = null;
        _this.bh = null;
        _this.a8 = ExpansionPanel.bw;
        _this.a7 = ExpansionPanel.bv;
        _this.a3 = ExpansionPanel.br;
        var a = _this.f();
        _this.g = a;
        a.z(_this);
        return _this;
    }
    ExpansionPanel.prototype.aw = function (a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        this.ax(a, b, c);
    };
    Object.defineProperty(ExpansionPanel.prototype, "ab", {
        get: function () {
            return this.aa;
        },
        set: function (a) {
            if (a == this.aa) {
                return;
            }
            var b = this.aa;
            this.aa = a;
            this.aw("Caption", b, this.aa);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ExpansionPanel.prototype, "bq", {
        get: function () {
            return this.bb;
        },
        set: function (a) {
            var b = this.bb;
            this.bb = a;
            if (b != this.bb) {
                this.aw("CaptionTextColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ExpansionPanel.prototype, "bj", {
        get: function () {
            return this.a4;
        },
        set: function (a) {
            var b = this.a4;
            this.a4 = a;
            if (b != this.a4) {
                this.aw("ActualCaptionTextColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ExpansionPanel.prototype, "bo", {
        get: function () {
            return this.a9;
        },
        set: function (a) {
            var b = this.a9;
            this.a9 = a;
            if (b != this.a9) {
                this.aw("CaptionCollapsedTextColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ExpansionPanel.prototype, "bp", {
        get: function () {
            return this.ba;
        },
        set: function (a) {
            var b = this.ba;
            this.ba = a;
            if (b != this.ba) {
                this.aw("CaptionExpandedTextColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ExpansionPanel.prototype, "ah", {
        get: function () {
            return this.ag;
        },
        set: function (a) {
            if (a == this.ag) {
                return;
            }
            var b = this.ag;
            this.ag = a;
            this.aw("Description", b, this.ag);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ExpansionPanel.prototype, "bz", {
        get: function () {
            return this.be;
        },
        set: function (a) {
            var b = this.be;
            this.be = a;
            if (b != this.be) {
                this.aw("DescriptionTextColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ExpansionPanel.prototype, "bk", {
        get: function () {
            return this.a5;
        },
        set: function (a) {
            var b = this.a5;
            this.a5 = a;
            if (b != this.a5) {
                this.aw("ActualDescriptionTextColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ExpansionPanel.prototype, "bx", {
        get: function () {
            return this.bc;
        },
        set: function (a) {
            var b = this.bc;
            this.bc = a;
            if (b != this.bc) {
                this.aw("DescriptionCollapsedTextColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ExpansionPanel.prototype, "by", {
        get: function () {
            return this.bd;
        },
        set: function (a) {
            var b = this.bd;
            this.bd = a;
            if (b != this.bd) {
                this.aw("DescriptionExpandedTextColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ExpansionPanel.prototype, "s", {
        get: function () {
            return this.p;
        },
        set: function (a) {
            var b = this.p;
            this.p = a;
            if (b != this.p) {
                this.aw("Elevation", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ExpansionPanel.prototype, "q", {
        get: function () {
            return this.o;
        },
        set: function (a) {
            var b = this.o;
            this.o = a;
            if (b != this.o) {
                this.aw("ActualElevation", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ExpansionPanel.prototype, "n", {
        get: function () {
            return this.m;
        },
        set: function (a) {
            var _this = this;
            if (a == this.m) {
                return;
            }
            this.at();
            var b = this.m;
            this.m = a;
            var c = this.h(this.m);
            var d = this.i(this.m);
            var e = this.j(this.m);
            var f = this.k(this.m);
            var g = this.l(this.m);
            c.play();
            d.play();
            e.play();
            f.play();
            g.play();
            c.finished.f(function (h) { return c.commitStyles(); });
            d.finished.f(function (h) { return d.commitStyles(); });
            e.finished.f(function (h) { return e.commitStyles(); });
            f.finished.f(function (h) { return f.commitStyles(); });
            g.finished.f(function (h) {
                g.commitStyles();
                _this.aw("Expanded", b, _this.m);
                if (_this.m) {
                    if (_this.onExpanded != null) {
                        _this.onExpanded(_this, new OnExpandedEventArgs());
                    }
                    else if (_this.onCollapsed != null) {
                        _this.onCollapsed(_this, new OnCollapsedEventArgs());
                    }
                }
            });
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ExpansionPanel.prototype, "b6", {
        get: function () {
            return this.bf;
        },
        set: function (a) {
            var b = this.bf;
            this.bf = a;
            if (b != this.bf) {
                this.aw("HeaderBackgroundColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ExpansionPanel.prototype, "bl", {
        get: function () {
            return this.a6;
        },
        set: function (a) {
            var b = this.a6;
            this.a6 = a;
            if (b != this.a6) {
                this.aw("ActualHeaderBackgroundColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ExpansionPanel.prototype, "b7", {
        get: function () {
            return this.bg;
        },
        set: function (a) {
            var b = this.bg;
            this.bg = a;
            if (b != this.bg) {
                this.aw("HeaderCollapsedBackgroundColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ExpansionPanel.prototype, "b8", {
        get: function () {
            return this.bh;
        },
        set: function (a) {
            var b = this.bh;
            this.bh = a;
            if (b != this.bh) {
                this.aw("HeaderExpandedBackgroundColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ExpansionPanel.prototype, "bn", {
        get: function () {
            return this.a8;
        },
        set: function (a) {
            var b = this.a8;
            this.a8 = a;
            if (b != this.a8) {
                this.aw("ActualUmbraShadowColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ExpansionPanel.prototype, "bm", {
        get: function () {
            return this.a7;
        },
        set: function (a) {
            var b = this.a7;
            this.a7 = a;
            if (b != this.a7) {
                this.aw("ActualPenumbraShadowColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ExpansionPanel.prototype, "bi", {
        get: function () {
            return this.a3;
        },
        set: function (a) {
            var b = this.a3;
            this.a3 = a;
            if (b != this.a3) {
                this.aw("ActualAmbientShadowColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    ExpansionPanel.prototype.f = function () {
        return new ExpansionPanelView();
    };
    ExpansionPanel.prototype.ax = function (a, b, c) {
        switch (a) {
            case "CaptionTextColor":
            case "CaptionExpandedTextColor":
            case "CaptionCollapsedTextColor":
            case "DescriptionTextColor":
            case "DescriptionExpandedTextColor":
            case "DescriptionCollapsedTextColor":
            case "HeaderBackgroundColor":
            case "HeaderCollapsedBackgroundColor":
            case "HeaderExpandedBackgroundColor":
            case "Expanded":
                var d = this.bl;
                var e = this.b4();
                var f = this.bj;
                var g = this.b0();
                var h = this.bk;
                var i = this.b2();
                var j = (d != e) || (f != g) || (h != i);
                if (j) {
                    this.bl = e;
                    this.bj = g;
                    this.bk = i;
                }
                else if (a == "Expanded") {
                    this.g.ak();
                }
                break;
            case "Elevation":
                this.q = this.s == -1 ? ExpansionPanel.r : this.s;
                break;
            case "ActualElevation":
            case "ActualHeaderBackgroundColor":
            case "ActualCaptionTextColor":
            case "ActualDescriptionTextColor":
            case "ActualUmbraShadowColor":
            case "ActualPenumbraShadowColor":
            case "ActualAmbientShadowColor":
            case "Caption":
            case "Description":
                this.g.ak();
                break;
        }
    };
    ExpansionPanel.prototype.h = function (a) {
        var b = this.bj;
        var c = this.b1(a);
        var d = a ? this.b() : this.a();
        var e = this.g.a(d);
        var f = [new AnimationKeyFrameProperty(7, b)];
        var g = [new AnimationKeyFrameProperty(7, c)];
        e.m.apply(e, tslib_1.__spread(f));
        e.m.apply(e, tslib_1.__spread(g));
        return KeyFrameAnimationFactory.f.c(e);
    };
    ExpansionPanel.prototype.i = function (a) {
        var b = this.bk;
        var c = this.b3(a);
        var d = a ? this.b() : this.a();
        var e = this.g.b(d);
        var f = [new AnimationKeyFrameProperty(7, b)];
        var g = [new AnimationKeyFrameProperty(7, c)];
        e.m.apply(e, tslib_1.__spread(f));
        e.m.apply(e, tslib_1.__spread(g));
        return KeyFrameAnimationFactory.f.c(e);
    };
    ExpansionPanel.prototype.j = function (a) {
        var b = this.bl;
        var c = this.b5(a);
        var d = a ? this.b() : this.a();
        var e = this.g.c(d);
        var f = [new AnimationKeyFrameProperty(2, b)];
        var g = [new AnimationKeyFrameProperty(2, c)];
        e.m.apply(e, tslib_1.__spread(f));
        e.m.apply(e, tslib_1.__spread(g));
        return KeyFrameAnimationFactory.f.c(e);
    };
    ExpansionPanel.prototype.k = function (a) {
        var b = this.g.r();
        if (b <= 0) {
            b = 500;
        }
        var c = a ? -b : 0;
        var d = a ? 0 : -b;
        var e = a ? 0 : 1;
        var f = a ? 1 : 0;
        var g = a ? this.b() : this.a();
        var h = new TranslateTransform();
        h.k = c;
        var i = new TranslateTransform();
        i.k = d;
        var j = this.g.d(g);
        var k = [new AnimationKeyFrameProperty(14, h), new AnimationKeyFrameProperty(1, e)];
        var l = [new AnimationKeyFrameProperty(14, i), new AnimationKeyFrameProperty(1, f)];
        j.m.apply(j, tslib_1.__spread(k));
        j.m.apply(j, tslib_1.__spread(l));
        return KeyFrameAnimationFactory.f.c(j);
    };
    ExpansionPanel.prototype.l = function (a) {
        var b = this.g.r();
        if (b <= 0) {
            b = 500;
        }
        var c = a ? 0 : b;
        var d = a ? b : 0;
        var e = a ? this.b() : this.a();
        var f = this.g.e(e);
        var g = [new AnimationKeyFrameProperty(10, c)];
        var h = [new AnimationKeyFrameProperty(10, d)];
        f.m.apply(f, tslib_1.__spread(g));
        f.m.apply(f, tslib_1.__spread(h));
        return KeyFrameAnimationFactory.f.c(f);
    };
    ExpansionPanel.prototype.a = function () {
        var a = new AnimationKeyFrameEffectTiming();
        a.g = 300;
        a.b = 3;
        return a;
    };
    ExpansionPanel.prototype.b = function () {
        var a = new AnimationKeyFrameEffectTiming();
        a.g = 300;
        a.b = 3;
        return a;
    };
    ExpansionPanel.prototype.at = function () {
        this.g.u();
    };
    ExpansionPanel.prototype.b0 = function () {
        return this.b1(this.n);
    };
    ExpansionPanel.prototype.b1 = function (a) {
        var b;
        var c = null;
        c = a ? this.bp : this.bo;
        if (null != c) {
            b = c;
        }
        else {
            b = null != this.bq ? this.bq : ExpansionPanel.bs;
        }
        return b;
    };
    ExpansionPanel.prototype.b2 = function () {
        return this.b3(this.n);
    };
    ExpansionPanel.prototype.b3 = function (a) {
        var b;
        var c = null;
        c = a ? this.by : this.bx;
        if (null != c) {
            b = c;
        }
        else {
            b = null != this.bz ? this.bz : ExpansionPanel.bt;
        }
        return b;
    };
    ExpansionPanel.prototype.b4 = function () {
        return this.b5(this.n);
    };
    ExpansionPanel.prototype.b5 = function (a) {
        var b;
        var c = null;
        c = a ? this.b8 : this.b7;
        if (null != c) {
            b = c;
        }
        else {
            b = null != this.b6 ? this.b6 : ExpansionPanel.bu;
        }
        return b;
    };
    ExpansionPanel.prototype.ar = function () {
        this.n = false;
    };
    ExpansionPanel.prototype.destroy = function () {
        this.provideRenderer(null);
    };
    ExpansionPanel.prototype.au = function () {
        this.n = true;
    };
    ExpansionPanel.prototype.notifySizeChanged = function () {
    };
    ExpansionPanel.prototype.provideHeader = function (a) {
        this.g.af(a);
    };
    ExpansionPanel.prototype.provideContentAreaOuter = function (a) {
        this.g.ae(a);
    };
    ExpansionPanel.prototype.provideContentAreaInner = function (a) {
        this.g.ad(a);
    };
    ExpansionPanel.prototype.provideRenderer = function (a) {
        this.g.ac(a);
    };
    ExpansionPanel.prototype.a2 = function () {
        this.n = !this.n;
    };
    ExpansionPanel.$t = markType(ExpansionPanel, 'ExpansionPanel', Base.$, [INotifyPropertyChanged_$type]);
    ExpansionPanel.bs = BrushUtil.g(188, 0, 0, 0);
    ExpansionPanel.bt = BrushUtil.g(188, 0, 0, 0);
    ExpansionPanel.r = 2;
    ExpansionPanel.bu = BrushUtil.g(255, 245, 245, 245);
    ExpansionPanel.bw = BrushUtil.g(66, 0, 0, 0);
    ExpansionPanel.bv = BrushUtil.g(30, 0, 0, 0);
    ExpansionPanel.br = BrushUtil.g(20, 0, 0, 0);
    return ExpansionPanel;
}(Base));
export { ExpansionPanel };
//# sourceMappingURL=ExpansionPanelView_combined.js.map
