import { Type } from "igniteui-react-core";
/**
 * Indicates which direction the popup will pop up in relation to the exclusion rectangle.
 */
export declare enum PopupDirection {
    /**
     * No specified direction.
     */
    Auto = 0,
    /**
     * Popup should be displayed downward.
     */
    Down = 1,
    /**
     * Popup should be displayed downward.
     */
    Up = 2
}
/**
 * @hidden
 */
export declare let PopupDirection_$type: Type;
