import { Base, Type, INotifyPropertyChanged, PropertyChangedEventArgs } from "igniteui-react-core";
import { DomRenderer, DomWrapper } from "igniteui-react-core";
import { Size } from "igniteui-react-core";
import { Popup_OuterAnimationInfo } from "./Popup_OuterAnimationInfo";
import { Popup_InnerAnimationInfo } from "./Popup_InnerAnimationInfo";
import { AnimationKeyFrameEffect } from "igniteui-react-core";
import { AnimationKeyFrameEffectTiming } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { PopupAlignment } from "./PopupAlignment";
import { PopupDirection } from "./PopupDirection";
import { Brush } from "igniteui-react-core";
import { OnClosedEventArgs } from "./OnClosedEventArgs";
import { OnPopupEventArgs } from "./OnPopupEventArgs";
import { PopupVisualModelExport } from "./PopupVisualModelExport";
/**
 * @hidden
 */
export declare class PopupView extends Base {
    static $t: Type;
    private k;
    private c;
    private o;
    private n;
    private m;
    private p;
    private f;
    private h;
    protected readonly d: Popup;
    protected readonly l: DomRenderer;
    protected ab(): void;
    ah(): void;
    ai(): void;
    s(): void;
    t(a: Popup_OuterAnimationInfo, b: Popup_InnerAnimationInfo): {
        p0?: Popup_OuterAnimationInfo;
        p1?: Popup_InnerAnimationInfo;
    };
    u(a: number): void;
    ae(): void;
    v(a: any): void;
    a(a: AnimationKeyFrameEffectTiming): AnimationKeyFrameEffect;
    b(a: AnimationKeyFrameEffectTiming): AnimationKeyFrameEffect;
    w(): void;
    private ak;
    readonly al: Size;
    private i;
    private j;
    private static r;
    private static q;
    aj(a: Rect, b: PopupDirection, c: PopupAlignment): Rect;
    private e;
    z(): void;
    private af;
    ac(a: DomRenderer): void;
    private g;
    private ag;
    protected x(a: DomWrapper): void;
    y(a: Popup): void;
    aa(): void;
    ad(): void;
}
/**
 * @hidden
 */
export declare class Popup extends Base implements INotifyPropertyChanged {
    static $t: Type;
    private i;
    private h;
    private a9;
    private n;
    private o;
    constructor();
    onClosed: (sender: any, args: OnClosedEventArgs) => void;
    onPopup: (sender: any, args: OnPopupEventArgs) => void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    protected at(a: string, b: any, c: any): void;
    k: PopupView;
    private x;
    y: number;
    private p;
    q: boolean;
    private v;
    aa: number;
    private static z;
    private u;
    w: number;
    private s;
    readonly t: boolean;
    private static a8;
    private a2;
    a5: Brush;
    private static a7;
    private a1;
    a4: Brush;
    private static a6;
    private a0;
    a3: Brush;
    protected j(): PopupView;
    protected av(a: string, b: any, c: any): void;
    am(): void;
    private l;
    private m;
    private a;
    private b;
    private ap;
    private f;
    private g;
    r(): boolean;
    aq(): void;
    private au;
    private ax;
    private ay;
    appendPopupContent(a: any): void;
    an(): void;
    destroy(): void;
    showRelativeToExclusionRect(a: Rect, b: PopupDirection, c: PopupAlignment): void;
    ar(a: Rect): void;
    notifySizeChanged(): void;
    provideRenderer(a: DomRenderer): void;
    ab(): any;
    aj(): string;
    c(): PopupVisualModelExport;
}
